/*******************************************************************
 *
 * OpenLLDP Port Header
 *
 * Licensed under a dual GPL/Proprietary license.  
 * See LICENSE file for more info.
 * 
 * File: lldp_port.h
 * 
 * Authors: Terry Simons (terry.simons@gmail.com)
 *
 *******************************************************************/

#ifndef LLDP_PORT_H
#define LLDP_PORT_H

#define MAX_INTERFACES 256
#define LLDP_SUCCESS 0
#define LLDP_FAIL -1

/* This datatype defines the LLDP headers */
struct eth_hdr {
  char dst[6];
  char src[6];
  uint16 ethertype;
};

/* This data type defines all possible values of admin status */
enum portAdminStatus {
  disabled = 0,
  enabledTxOnly,
  enabledRxOnly,
  enabledRxTx
};

struct lldp_port {
  // The socket descriptor for this interface.
  int socket;       
  // The interface name.
  char *if_name;    
  // The interface index.
  uint32 if_index; 
  //Index of this particulare port st in the global array lldp_ports[MAX_IF]
  int8 uiPortIndex; 
  // The interface MTU.
  uint16 mtu;      
  uint8 source_mac[6];
  uint8 source_ipaddr[4];
  lldp_rx_port rx;
  lldp_tx_port tx;
  uint8 portEnabled;
  uint8 medTransmitEnabled; // Always TRUE of an endpoint device
  uint8 adminStatus;
};

#endif /* LLDP_PORT_H */
